val ujsonVersion = "3.3.1"
val scalajsVersion = "2.8.0"
val scalatagsVersion = "0.12.0"
val toolkitVersion = "0.2.1"
val webSocketVersion = "1.5.4"
val caskVersion = "0.9.4"
val slf4jVersion = "2.0.5"
val reflectionsVersion = "0.10.2"

val options = List("-deprecation", "-feature", "-language:fewerBraces", "-Xfatal-warnings")

lazy val webappLib = crossProject(JSPlatform, JVMPlatform).in(file("."))
  .settings(
    scalaVersion := "3.5.0",
    scalacOptions ++= options,
  ).jsSettings(
    jsEnv := new org.scalajs.jsenv.jsdomnodejs.JSDOMNodeJSEnv(),
    testFrameworks += new TestFramework("utest.runner.Framework"),
    Test / test := {},
    Test / testOnly := {},
    libraryDependencies ++= Seq(
      "com.lihaoyi" %% "ujson" % ujsonVersion,
      "org.scala-js" %%% "scalajs-dom" % scalajsVersion,
      "com.lihaoyi" %%% "scalatags" % scalatagsVersion,
    ),
  ).jvmSettings(
    libraryDependencies ++= Seq(
      "org.java-websocket" % "Java-WebSocket" % webSocketVersion,
      "com.lihaoyi" %% "cask" % caskVersion,
      "org.slf4j" % "slf4j-nop" % slf4jVersion,
      "org.reflections" % "reflections" % reflectionsVersion,
      "org.scala-lang" %% "toolkit-test" % toolkitVersion % Test,
    ),
  )
