package cs214.webapp
package client

import org.scalajs.dom

/** The ClientApp interface is used by clients to connect to a server. */
trait ClientApp:
  def appID: AppID
  def uiID: UIID 
  def init(instanceID: InstanceID, userID: UserID, endpoint: String, target: dom.Element): ClientAppInstance

/** The ClientAppInstance interface is used by the server to store the state of
  * a client UI.
  */
trait ClientAppInstance:
  def onMessage(msg: util.Try[ujson.Value]): Unit
