package cs214.webapp.server
package utils

import java.lang.reflect.Modifier
import scala.jdk.CollectionConverters.*
import org.reflections.Reflections

/** Finds all apps under the `apps` package. A class extending `StateMachine` is
  * considered to be an app.
  */
object AppsLoader:
  private val APPS_PACKAGE = "apps"

  def loadApps(): List[Class[?]] =
    val reflections = new Reflections(APPS_PACKAGE)
    reflections
      .getSubTypesOf(classOf[StateMachine[?, ?, ?]])
      .asScala
      .toList
      .filterNot(cls => Modifier.isAbstract(cls.getModifiers) || cls.isInterface())
